Index: uspace/srv/taskmon/meson.build
===================================================================
--- uspace/srv/taskmon/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/taskmon/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2010 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'corecfg' ]
 src = files('taskmon.c')
Index: uspace/srv/taskmon/taskmon.c
===================================================================
--- uspace/srv/taskmon/taskmon.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/taskmon/taskmon.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -136,4 +136,6 @@
 int main(int argc, char *argv[])
 {
+	loc_srv_t *srv;
+
 	printf("%s: Task Monitoring Service\n", NAME);
 
@@ -150,5 +152,5 @@
 	async_set_fallback_port_handler(corecfg_client_conn, NULL);
 
-	errno_t rc = loc_server_register(NAME);
+	errno_t rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Failed registering server: %s.\n",
@@ -158,6 +160,7 @@
 
 	service_id_t sid;
-	rc = loc_service_register(SERVICE_NAME_CORECFG, &sid);
+	rc = loc_service_register(srv, SERVICE_NAME_CORECFG, &sid);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
 		printf("%s: Failed registering service: %s.\n",
 		    NAME, str_error(rc));
Index: uspace/srv/test/chardev-test/main.c
===================================================================
--- uspace/srv/test/chardev-test/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/test/chardev-test/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2017 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -118,9 +118,10 @@
 {
 	errno_t rc;
+	loc_srv_t *srv;
 
 	printf("%s: Character device test service\n", NAME);
 	async_set_fallback_port_handler(chardev_test_connection, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Failed registering server.: %s\n", NAME, str_error(rc));
@@ -140,20 +141,23 @@
 	partialx_srvs.sarg = NULL;
 
-	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_SMALLX, &smallx_svc_id);
+	rc = loc_service_register(srv, SERVICE_NAME_CHARDEV_TEST_SMALLX,
+	    &smallx_svc_id);
 	if (rc != EOK) {
 		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
-		return rc;
-	}
-
-	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_LARGEX, &largex_svc_id);
+		goto error;
+	}
+
+	rc = loc_service_register(srv, SERVICE_NAME_CHARDEV_TEST_LARGEX,
+	    &largex_svc_id);
 	if (rc != EOK) {
 		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
-		return rc;
-	}
-
-	rc = loc_service_register(SERVICE_NAME_CHARDEV_TEST_PARTIALX, &partialx_svc_id);
+		goto error;
+	}
+
+	rc = loc_service_register(srv, SERVICE_NAME_CHARDEV_TEST_PARTIALX,
+	    &partialx_svc_id);
 	if (rc != EOK) {
 		printf("%s: Failed registering service.: %s\n", NAME, str_error(rc));
-		return rc;
+		goto error;
 	}
 
@@ -164,4 +168,13 @@
 	/* Not reached */
 	return 0;
+error:
+	if (smallx_svc_id != 0)
+		loc_service_unregister(srv, smallx_svc_id);
+	if (largex_svc_id != 0)
+		loc_service_unregister(srv, largex_svc_id);
+	if (partialx_svc_id != 0)
+		loc_service_unregister(srv, partialx_svc_id);
+	loc_server_unregister(srv);
+	return rc;
 }
 
Index: uspace/srv/test/ipc-test/main.c
===================================================================
--- uspace/srv/test/ipc-test/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/test/ipc-test/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2018 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -48,4 +48,5 @@
 #include <mem.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <task.h>
 
@@ -53,4 +54,8 @@
 
 static service_id_t svc_id;
+
+enum {
+	max_rw_buf_size = 16384,
+};
 
 /** Object in read-only memory area that will be shared.
@@ -67,4 +72,12 @@
  */
 static char rw_data[] = "Hello, world!";
+
+/** Buffer for reading/writing via read/write messages.
+ *
+ * It is allocated / size is set by IPC_TEST_SET_RW_BUF_SIZE
+ */
+static void *rw_buf;
+/** Read/write buffer size */
+size_t rw_buf_size;
 
 static void ipc_test_get_ro_area_size_srv(ipc_call_t *icall)
@@ -182,4 +195,103 @@
 }
 
+static void ipc_test_set_rw_buf_size_srv(ipc_call_t *icall)
+{
+	size_t size;
+	void *nbuf;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ipc_test_set_rw_buf_size_srv");
+
+	size = ipc_get_arg1(icall);
+
+	if (size == 0) {
+		async_answer_0(icall, ERANGE);
+		log_msg(LOG_DEFAULT, LVL_ERROR,
+		    "Requested read/write buffer size is zero.");
+		return;
+	}
+
+	if (size > max_rw_buf_size) {
+		async_answer_0(icall, ERANGE);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Requested read/write buffer "
+		    "size > %u", max_rw_buf_size);
+		return;
+	}
+
+	nbuf = realloc(rw_buf, size);
+	if (nbuf == NULL) {
+		async_answer_0(icall, ENOMEM);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Out of memory.");
+		return;
+	}
+
+	rw_buf = nbuf;
+	rw_buf_size = size;
+	async_answer_0(icall, EOK);
+}
+
+static void ipc_test_read_srv(ipc_call_t *icall)
+{
+	ipc_call_t call;
+	errno_t rc;
+	size_t size;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ipc_test_read_srv");
+
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(icall, EREFUSED);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "data_read_receive failed");
+		return;
+	}
+
+	if (size > rw_buf_size) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Invalid read size.");
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, rw_buf, size);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR,
+		    "data_read_finalize failed");
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	async_answer_0(icall, EOK);
+}
+
+static void ipc_test_write_srv(ipc_call_t *icall)
+{
+	ipc_call_t call;
+	errno_t rc;
+	size_t size;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ipc_test_write_srv");
+
+	if (!async_data_write_receive(&call, &size)) {
+		async_answer_0(icall, EREFUSED);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "data_write_receive failed");
+		return;
+	}
+
+	if (size > rw_buf_size) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Invalid write size.");
+		return;
+	}
+
+	rc = async_data_write_finalize(&call, rw_buf, size);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR,
+		    "data_write_finalize failed");
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	async_answer_0(icall, EOK);
+}
+
 static void ipc_test_connection(ipc_call_t *icall, void *arg)
 {
@@ -212,4 +324,13 @@
 			ipc_test_share_in_rw_srv(&call);
 			break;
+		case IPC_TEST_SET_RW_BUF_SIZE:
+			ipc_test_set_rw_buf_size_srv(&call);
+			break;
+		case IPC_TEST_READ:
+			ipc_test_read_srv(&call);
+			break;
+		case IPC_TEST_WRITE:
+			ipc_test_write_srv(&call);
+			break;
 		default:
 			async_answer_0(&call, ENOTSUP);
@@ -222,4 +343,5 @@
 {
 	errno_t rc;
+	loc_srv_t *srv;
 
 	printf("%s: IPC test service\n", NAME);
@@ -232,5 +354,5 @@
 	}
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server. (%s)\n",
@@ -239,6 +361,7 @@
 	}
 
-	rc = loc_service_register(SERVICE_NAME_IPC_TEST, &svc_id);
-	if (rc != EOK) {
+	rc = loc_service_register(srv, SERVICE_NAME_IPC_TEST, &svc_id);
+	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service. (%s)\n",
 		    str_error(rc));
Index: uspace/srv/test/ipc-test/meson.build
===================================================================
--- uspace/srv/test/ipc-test/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/test/ipc-test/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2018 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'ipctest' ]
 src = files('main.c')
Index: uspace/srv/vfs/vfs_node.c
===================================================================
--- uspace/srv/vfs/vfs_node.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/vfs/vfs_node.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -66,5 +66,5 @@
 
 /** VFS node hash table operations. */
-hash_table_ops_t nodes_ops = {
+const hash_table_ops_t nodes_ops = {
 	.hash = nodes_hash,
 	.key_hash = nodes_key_hash,
Index: uspace/srv/volsrv/empty.c
===================================================================
--- uspace/srv/volsrv/empty.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/volsrv/empty.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,5 +62,5 @@
 	label_bd_t lbd;
 
-	rc = block_init(sid, 2048);
+	rc = block_init(sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
@@ -83,5 +83,5 @@
 	label_bd_t lbd;
 
-	rc = block_init(sid, 2048);
+	rc = block_init(sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error opening "
Index: uspace/srv/volsrv/volsrv.c
===================================================================
--- uspace/srv/volsrv/volsrv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/volsrv/volsrv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,4 +62,5 @@
 	vol_volumes_t *volumes = NULL;
 	vol_parts_t *parts = NULL;
+	loc_srv_t *srv = NULL;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_init()");
@@ -79,5 +80,5 @@
 	async_set_fallback_port_handler(vol_client_conn, parts);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
@@ -86,5 +87,5 @@
 
 	service_id_t sid;
-	rc = loc_service_register(SERVICE_NAME_VOLSRV, &sid);
+	rc = loc_service_register(srv, SERVICE_NAME_VOLSRV, &sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
@@ -95,4 +96,6 @@
 	return EOK;
 error:
+	if (srv != NULL)
+		loc_server_unregister(srv);
 	vol_volumes_destroy(volumes);
 	vol_parts_destroy(parts);
Index: version
===================================================================
--- version	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ version	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,5 +28,5 @@
 
 
-HELENOS_RELEASE = 0.11.1
-HELENOS_CODENAME = Jubilee
-HELENOS_COPYRIGHT = Copyright (c) 2001-2021 HelenOS project
+HELENOS_RELEASE = 0.14.1
+HELENOS_CODENAME = Aladar
+HELENOS_COPYRIGHT = Copyright (c) 2001-2024 HelenOS project
